% This script computes the measurements accoding to the measurmeent
% equation in the article. The satellite data ara simulated
%
% Julien LESOUPLE 12 sep 2018

% Parameters
sigma_uere=5; % Pseudoranges standard deviation
f_L1=1575.42*1e6; % L1 frequency
Lambda_L1=c/f_L1; % L1 Wavelength
sigma_uere_dot=2*Lambda_L1; % Pseudorange rates standard deviation
n=8; % Number of satellites
CN0_nom=47+3*rand(n,1); % Nominal C/N0
CN0_mp=25+3*rand(n,1); % MP C/N0
ID_MP=[2,3,8]; % Where are MP?
MP_PR_bias=[-50;60;40;-40;50;80;-30;-60]; % What are there amplitudes for PR? (totally arbitrary)
MP_PR_rate_bias=[12;-32;25;5;-8;15;-24;-8]; % What are there amplitudes for PR rate? (totally arbitrary)
t1_MP=50; % When MP starts?
t2_MP=130; % Where MP ends?

% Initialization
yt=zeros(2*n,T);
CN0=zeros(n,T);
mp_bias_th=zeros(2*n,T);

% Geometry matrix
az=2*pi*rand(n,1);
elev=pi/2*rand(n,1); % Satellites are supposed motionless for the simulation
H1=[cos(elev).*sin(az) , cos(elev).*cos(az) , sin(elev) , ones(n,1)]; % Geometry matrix, http://www.navipedia.net/index.php/Code_Based_Positioning_(SPS)#cite_note-2
H=[kron(H1,[1 0]);kron(H1,[0,1])];

% Noise covariance matrix
R=blkdiag(sigma_uere^2*eye(n),sigma_uere_dot^2*eye(n));

% Create measurements
for t=1:T
    yt(:,t)=H*Xt(:,t)+mvnrnd(zeros(2*n,1),R)';
    CN0(:,t)=CN0_nom;
    if mp_scenario && t>=t1_MP && t<=t2_MP
       CN0(ID_MP,t)=CN0_mp(ID_MP);
       yt([ID_MP;n+ID_MP],t)=yt([ID_MP;n+ID_MP],t)+[MP_PR_bias(ID_MP);MP_PR_rate_bias(ID_MP)];
       mp_bias_th([ID_MP;n+ID_MP],t)=[MP_PR_bias(ID_MP);MP_PR_rate_bias(ID_MP)];
    end
end

if plot_skyplot
    theta=[0:0.1:2*pi,2*pi];
    radius=(pi/2-elev)*180/pi;
    x=radius.*cos(pi/2-az); y=radius.*sin(pi/2-az);
    scatter(x,y)
    hold on 
    plot(90*cos(theta),90*sin(theta),'k')
    axis square
    hold off
    set(gca,'YTickLabel',[])
    set(gca,'XTickLabel',[])
    box on
    title('Skyplot of the scenario')
end
