function [ W ] = weights_cn0(CN0_vec)
%WEIGHTS_CN0 computes the weights from CN0 values
%   Computes the weights as a function of the C/N0 values, as described in 
%   the article 
%
%   Julien LESOUPLE 12 sep 2018

% Parameters
s1=45;
s0=20;
A=30;
a=80;

n=length(CN0_vec);
w=ones(n,1);
for i=1:n
    CN0=CN0_vec(i);
    if CN0<s1
        aa=(CN0-s1)/(s0-s1);
        bb=A*10^((s0-s1)/a)-1;
        cc=10^(-(CN0-s1)/a);
        w(i)=(cc*(bb*aa+1));
    end
end
W=1./[w;w];
end
